"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.analyzeLineCountByCategory = exports.isToDo = exports.isComment = exports.isEmptyBlockComment = exports.isMixedComment = exports.isBlockComment = exports.isSingleLineComment = exports.analyzeLineCount = void 0;
const fs = __importStar(require("fs"));
/**
 * Analyze the line count of the specified file
 */
const analyzeLineCount = (filePath) => {
    const fileContent = fs.readFileSync(filePath, 'utf8');
    return fileContent.split('\n').length;
};
exports.analyzeLineCount = analyzeLineCount;
const isSingleLineComment = (line = "") => line.startsWith('//');
exports.isSingleLineComment = isSingleLineComment;
const isBlockComment = (line = "") => line.startsWith('/*') && line.endsWith('*/');
exports.isBlockComment = isBlockComment;
const isMixedComment = (line = "") => (line.startsWith('/*') && !line.endsWith('*/')) || line.startsWith('*');
exports.isMixedComment = isMixedComment;
const isEmptyBlockComment = (line = "") => line.startsWith('/*') && !line.endsWith('*/');
exports.isEmptyBlockComment = isEmptyBlockComment;
const isComment = (line = "") => {
    return (0, exports.isSingleLineComment)(line) || (0, exports.isBlockComment)(line) || (0, exports.isMixedComment)(line) || (0, exports.isEmptyBlockComment)(line);
};
exports.isComment = isComment;
const isToDo = (line = "") => {
    return (line.includes('TODO'));
};
exports.isToDo = isToDo;
const analyzeLineCountByCategory = (filePath, output) => {
    var _a;
    const fileContent = fs.readFileSync(filePath, 'utf8');
    const lines = fileContent.split('\n') || "";
    let lineIndex = 0;
    while (lineIndex < lines.length) {
        const line = lines[lineIndex].trim();
        output.Physical++;
        if (line === '')
            output.Empty++;
        else if ((0, exports.isSingleLineComment)(line)) {
            output.SingleLineComment++;
            output.Comment++;
        }
        else if ((0, exports.isBlockComment)(line)) {
            output.BlockComment++;
            output.Comment++;
        }
        else if ((0, exports.isMixedComment)(line)) {
            output.Mixed++;
            output.Comment++;
            let blockCommentLines = 0;
            while (lineIndex < lines.length && !((_a = lines[lineIndex]) === null || _a === void 0 ? void 0 : _a.endsWith('*/'))) {
                blockCommentLines++;
                lineIndex++;
            }
            if ((0, exports.isEmptyBlockComment)(line))
                output.EmptyBlockComment += blockCommentLines;
            else
                output.BlockComment += blockCommentLines;
        }
        if ((0, exports.isToDo)(line))
            output.ToDo++;
        lineIndex++;
    }
    output.Source = output.Physical - output.Comment - output.Empty - output.ToDo;
    return output;
};
exports.analyzeLineCountByCategory = analyzeLineCountByCategory;
